﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SluzbyAplikaci.KOMETA.Models
{
    class Inzerat
    {
        public int id { get; set; }
        public DateTime datumOd { get; set; }
        public DateTime datumDo { get; set; }
        public int status { get; set; }
        public int idZam { get; set; }

        public static List<Inzerat> SelectInzeraty()
        {

            List<Inzerat> seznam = new List<Inzerat>();
            String sqlStr = "SELECT id, datumOd, datumDo, status, idZam FROM Inzerat_Inzerat WHERE ukonceno = 0";


            using (SqlConnection conn = new SqlConnection("Data Source=kometa.database.windows.net, 1433;Initial Catalog=eTrainingQ; Persist Security Info=False; user id=eTrainingUsr; password=Kcd#18Sejv0vice; Encrypt=True"))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Inzerat item;

                    while (reader.Read())
                    {
                        item = new Inzerat();
                        item.id = reader.GetInt32(0);
                        item.datumOd = reader.GetDateTime(1);
                        item.datumDo = reader.GetDateTime(2);
                        item.status = reader.GetInt32(3);
                        if (reader.GetValue(4) != DBNull.Value) item.idZam = reader.GetInt32(4);

                        seznam.Add(item);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    string logSlozka = @"c:\winServices\Problem_sluzba";
                    if (!Directory.Exists(logSlozka)) Directory.CreateDirectory(logSlozka);
                    // *** nazev souboru, do ktereho se loguje
                    using (FileStream fs = new FileStream(logSlozka + "\\Kometa.txt", FileMode.OpenOrCreate, FileAccess.Write))
                    {
                        StreamWriter swr = new StreamWriter(fs);

                        swr.BaseStream.Seek(0, SeekOrigin.End);  //*** vyhledani konce logu
                        swr.WriteLine("\n" + DateTime.Now.ToShortDateString() + ":\n");
                        swr.WriteLine("Chyba při načtení inzerátů " + ex.Message + "\n");
                        swr.Flush();
                    }
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }

        public static void UpdateUkonceno(string IDs)
        {
            String sqlStr = "UPDATE Inzerat_Inzerat SET ukonceno=1 WHERE id IN (" + IDs + ")";

            using (SqlConnection conn = new SqlConnection("Data Source=kometa.database.windows.net, 1433;Initial Catalog=eTrainingQ; Persist Security Info=False; user id=eTrainingUsr; password=Kcd#18Sejv0vice; Encrypt=True"))
            {
                try
                {
                    conn.Open();

                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();

                }


                catch (Exception ex)
                {
                    string logSlozka = @"c:\winServices\Problem_sluzba";
                    if (!Directory.Exists(logSlozka)) Directory.CreateDirectory(logSlozka);
                    // *** nazev souboru, do ktereho se loguje
                    using (FileStream fs = new FileStream(logSlozka + "\\Kometa.txt", FileMode.OpenOrCreate, FileAccess.Write))
                    {
                        StreamWriter swr = new StreamWriter(fs);

                        swr.BaseStream.Seek(0, SeekOrigin.End);  //*** vyhledani konce logu
                        swr.WriteLine("\n" + DateTime.Now.ToShortDateString() + ":\n");
                        swr.WriteLine("Chyba při updatu inzerátů " + ex.Message + "\n");
                        swr.Flush();
                    }
                }
                finally
                {
                    conn.Close();
                }
            }
        }

        public static void UpdateZam(string IDs)
        {
            String sqlStr = "UPDATE Zamestnanec SET idZapujcenehoUseku=null WHERE id IN (" + IDs + ")";

            using (SqlConnection conn = new SqlConnection("Data Source=kometa.database.windows.net, 1433;Initial Catalog=eTrainingQ; Persist Security Info=False; user id=eTrainingUsr; password=Kcd#18Sejv0vice; Encrypt=True"))
            {
                try
                {
                    conn.Open();

                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();

                }


                catch (Exception ex)
                {
                    string logSlozka = @"c:\winServices\Problem_sluzba";
                    if (!Directory.Exists(logSlozka)) Directory.CreateDirectory(logSlozka);
                    // *** nazev souboru, do ktereho se loguje
                    using (FileStream fs = new FileStream(logSlozka + "\\Kometa.txt", FileMode.OpenOrCreate, FileAccess.Write))
                    {
                        StreamWriter swr = new StreamWriter(fs);

                        swr.BaseStream.Seek(0, SeekOrigin.End);  //*** vyhledani konce logu
                        swr.WriteLine("\n" + DateTime.Now.ToShortDateString() + ":\n");
                        swr.WriteLine("Chyba při updatu Zaměstnance " + ex.Message + "\n");
                        swr.Flush();
                    }
                }
                finally
                {
                    conn.Close();
                }
            }
        }
        
    }
}
