﻿using SluzbyAplikaci.KOMETA.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SluzbyAplikaci.KOMETA
{
    class Sluzba
    {
        public static void KontrolaInzeratu()
        {
            string ukonceniInzeratu = "";
            string ukonceniZapujcky = "";

            foreach (var item in Inzerat.SelectInzeraty())
            {
                if (item.status == 1 && item.datumOd < DateTime.Now.Date)
                {
                    ukonceniInzeratu += item.id + ",";
                }
                else if (item.status == 2 && item.datumDo < DateTime.Now.Date)
                {
                    ukonceniInzeratu += item.id + ",";
                    ukonceniZapujcky += item.idZam + ",";
                }
            }

            if (ukonceniInzeratu != "")
            {
                ukonceniInzeratu = ukonceniInzeratu.Remove(ukonceniInzeratu.Length-1, 1);
                Inzerat.UpdateUkonceno(ukonceniInzeratu);
            }
            if (ukonceniZapujcky != "")
            {
                ukonceniZapujcky = ukonceniZapujcky.Remove(ukonceniZapujcky.Length - 1, 1);
                Inzerat.UpdateZam(ukonceniZapujcky);
            }
        }
        public static void SmazaniNeaktivnichZam()
        {
            string seznamZamProSmazani = Zamestnanec.SelectZamKeSmazani();
            if (seznamZamProSmazani != "")
            {
                Zamestnanec.SmazatZam(seznamZamProSmazani);
            }
        }
    }
}
